#pragma once

#include "visa.h"

class CVISADev
{
public:
	CVISADev(CString sVisaResourceString, bool bFileDump = false);
	~CVISADev(void);

    bool IsDeviceReady(void);
    bool Write(CString sCommand, bool bShowError = false);
    
    CString Read(bool bShowError = false); 
    CString Request(CString sCommand, bool bShowError = false);

    bool ReadErrorQueue(bool bShowContents = true);

	bool CVISADev::CopyFile2Device(CString sFilename, CString sTargetDir, bool bShowError = false);

protected:
	ViStatus status; /* For checking errors */
    ViSession defaultRM, instr; /* Communication channels */

	bool m_bDeviceReady; //is Device ready?important to suppress infinit errors          
    LONG m_lTotalMessageCount; //for debugging purpose
    CString m_sVisaResourceString; //VISA address where to find the box

	 
	//some static members to manage Debug file
	static CStdioFile m_Debugfile; //for logging
	static bool m_bDebugfileIsOpen;
	static int m_nInstanceCount; 
};
