#ifndef SCPISOCKET_H
#define SCPISOCKET_H

#include <QTcpSocket>

typedef enum
{
    SCPISOCKET_INIT,
    SCPISOCKET_OPEN,
    SCPISOCKET_CONNECTED
}
SCPISOCKET_STATE_TYPE;

class SCPIsocket : public QObject
{
    Q_OBJECT

public:
    SCPIsocket(const QString & hostName);
    SCPIsocket(void);
    ~SCPIsocket();

    void connectToHost(const QString & hostName);
    qint64 write ( const QString & data, bool suppressLF = false);
    qint64 write ( const char * data, qint64 maxSize, bool suppressLF = false );
    qint64 read ( char * data, qint64 maxSize, int waitBeforeReadMs = 1000 );
    QString read(qint64 maxSize, int waitBeforeReadMs = 1000);
    QString request(const QString & data, qint64 maxSize, int waitBeforeReadMs = 1000);
    qint64 waitForData ( int waitBeforeReadMs = 1000 );
    bool isConnected(void) { return m_isConnected; }

    bool readErrorQueue(bool showErrors = true);

 public slots:
    void readData(void);
    void connected(void);
    void displayError(QAbstractSocket::SocketError socketError);

private:
    QTcpSocket *tcpSocket;
    bool m_isConnected;
};

#endif // SCPISOCKET_H
