#ifndef TARGETDIRBROWSER_H
#define TARGETDIRBROWSER_H

#include <QtGui/QDialog>
#include <QModelIndex>

class SCPIsocket;
class TreeModel;

namespace Ui {
    class TargetDirBrowser;
}

class TargetDirBrowser : public QDialog {
    Q_OBJECT
public:
    TargetDirBrowser(SCPIsocket *targetSocket, QString topDirectory, QWidget *parent = 0);
    ~TargetDirBrowser();

    QString &getTargetDir(void) { return targetDir; };

protected:
    void changeEvent(QEvent *e);
    void fillDirectoryData(int level);

private:
    Ui::TargetDirBrowser *m_ui;
    SCPIsocket *m_targetSocket;
    QString m_topDirectory;

    TreeModel *pModel;
    QString directoryData;

    QString targetDir;

public slots:
    void clicked(const QModelIndex &index);


};

#endif // TARGETDIRBROWSER_H
