#include <string>

//defines structs for socket handling
#ifdef WIN32
#include "winsock.h"
#else
#include <netinet/in.h>
#endif

using namespace std;

typedef struct sockaddr_in SockAddrStruct;
typedef struct hostent     HostInfoStruct;

class TcpClient
{
public:
	TcpClient();
	~TcpClient();

	void connectToServer( string &hostname, int port );
	void disconnect( );
	void transmit( string &txString );
	void receive( string &rxString );

	string getCurrentHostName( ) const;
	int    getCurrentPort( ) const;

private:
	string           currentHostName;
	int              currentPort;

#ifdef WIN32
	SOCKET           currentSocketDescr;
#else //LINUX
	int              currentSocketDescr;
#endif

	SockAddrStruct   serverAddress;
	HostInfoStruct * currentHostInfo;
	bool             clientIsConnected;

	int              receiveBufferSize;
};
